/*
 * $Source: /var/cvs/d2x/arch/linux/include/ipx_ld.h,v $
 * $Revision: 1.3 $
 * $Author: bradleyb $
 * $Date: 2001/10/19 07:39:26 $
 *
 * parts from:
 * ipx.h header file for IPX for the DOS emulator
 * 		Tim Bird, tbird@novell.com
 *
 * $Log: ipx_ld.h,v $
 * Revision 1.3  2001/10/19 07:39:26  bradleyb
 * remove pesky * from RCS log entry
 *
 * Revision 1.2  2001/10/19 07:29:37  bradleyb
 * Brought linux networking in line with d1x, moved some arch/linux_* stuff to arch/linux/
 *
 *
 */

#ifndef _IPX_DOSEMU
#define _IPX_DOSEMU

#define MAX_PACKET_DATA		1500

typedef struct IPXAddressStruct {
  u_char Network[4] __attribute__((packed));
  u_char Node[6] __attribute__((packed));
  u_char Socket[2] __attribute__((packed));
} IPXAddress_t;

typedef struct IPXPacketStructure {
  u_short Checksum __attribute__((packed));
  u_short Length __attribute__((packed));
  u_char TransportControl __attribute__((packed));
  u_char PacketType __attribute__((packed));
  IPXAddress_t Destination __attribute__((packed));
  IPXAddress_t Source __attribute__((packed));
} IPXPacket_t;

typedef struct ipx_socket_struct {
#ifdef DOSEMU
  struct ipx_socket_struct *next;
  far_t listenList;
  int listenCount;
  far_t AESList;
  int AESCount;
  u_short PSP;
#endif  
  u_short socket;
  int fd;
} ipx_socket_t;

#include "mono.h"
#ifndef NMONO
#define n_printf(format, args...) _mprintf(1, format, ## args)
#else
#define n_printf(format, args...) fprintf(stderr,format, ## args)
#endif
#define enter_priv_on()
#define leave_priv_setting()

#endif
